/*!
 * \file core.h
 *
 * \author Christos Choutouridis AEM:8997 <cchoutou@ece.auth.gr>
 */

#ifndef __core__
#define __core__

#include "msg_impl.h"

extern msgList_t msgList;

device_t addr2device (uint32_t in_addr);
uint32_t device2addr (const device_t* dev);
device_t ip2device (devIP_t* ip);
devIP_t  device2ip (const device_t* dev);
devIP_t  addr2ip (uint32_t in_addr);

status_t  cMsg_parse (cMsg_t* cMsg, char_t* rawMsg, size_t size);
uint32_t  cMsg_getFrom (cMsg_t* cMsg);
uint32_t  cMsg_getTo (cMsg_t* cMsg);
uint64_t  cMsg_getTs (cMsg_t* cMsg);
char_t*   cMsg_getText (cMsg_t* cMsg);
bool      cMsg_equal (cMsg_t* m1, cMsg_t* m2);

//device_t* devList_get (msgList_t* this, mIter_t it);
//device_t* devList_getNext (device_t* d);
status_t  devList_add (msgList_t* this, mIter_t it, device_t* dev);
//void      devList_free (msgList_t* this, mIter_t it);

status_t  msgList_init (msgList_t* msgList);
mIter_t   msgList_find (msgList_t* this, msg_t* msg);
void      msgList_add (msgList_t* this, msg_t* msg);


status_t log_init (void);

void log_msg_io (msg_t* msg);
void log_msg_new (msg_t* msg);
void log_debug (const char *fmt, ...);
void log_error (const char *fmt, ...);

#endif /* __core__ */
